//
//  ShapePickerView.swift
//  Feels (iOS)
//
//  Created by Trey Tartt on 4/2/22.
//

import SwiftUI

struct ShapePickerView: View {
    @AppStorage(UserDefaultsStore.Keys.theme.rawValue, store: GroupUserDefaults.groupDefaults) private var theme: Theme = .system
    @State var shapeRefreshToggleThing: Bool = false
    @AppStorage(UserDefaultsStore.Keys.textColor.rawValue, store: GroupUserDefaults.groupDefaults) private var textColor: Color = DefaultTextColor.textColor
    @AppStorage(UserDefaultsStore.Keys.moodTint.rawValue, store: GroupUserDefaults.groupDefaults) private var moodTint: MoodTints = .Default
    @AppStorage(UserDefaultsStore.Keys.shape.rawValue, store: GroupUserDefaults.groupDefaults) private var shape: BGShape = .circle
    
    var body: some View {
        ZStack {
            theme.currentTheme.secondaryBGColor
            
            VStack {
                HStack {
                    Spacer()
                    Text(shapeRefreshToggleThing.description.localizedLowercase)
                        .hidden()
                    Image(systemName: "arrow.triangle.2.circlepath.circle")
                        .resizable()
                        .frame(width: 20, height: 20, alignment: .trailing)
                        .foregroundColor(Color(UIColor.systemGray))
                        .onTapGesture {
                            shapeRefreshToggleThing.toggle()
                        }
                }
                Spacer()
            }
            .padding()
            
            VStack(alignment:.leading) {
                Text(String(localized: "customize_view_view_pick_shape"))
                    .padding([.leading])
                    .foregroundColor(textColor)
                
                Divider()
                
                HStack {
                    ForEach(BGShape.allCases, id: \.rawValue) { ashape in
                        ashape.view(withText: Text("20"),
                                    bgColor: moodTint.color(forMood: Mood.allValues.randomElement()!), textColor: textColor)
                        .frame(height: 50)
                        .frame(minWidth: 0, maxWidth: .infinity)
                        .onTapGesture {
                            let impactMed = UIImpactFeedbackGenerator(style: .heavy)
                            impactMed.impactOccurred()
                            shape = ashape
                            EventLogger.log(event: "change_mood_shape_id", withData: ["id": shape.rawValue])
                        }
                        .contentShape(Rectangle())
                        .background(
                            RoundedRectangle(cornerRadius: 10, style: .continuous)
                                .fill(shape == ashape ? theme.currentTheme.bgColor : .clear)
                                .padding(-5)
                        )
                    }
                }
            }
            .padding()
        }
        .fixedSize(horizontal: false, vertical: true)
        .cornerRadius(Constants.viewsCornerRaidus, corners: [.topLeft, .topRight, .bottomLeft, .bottomRight])
    }
}

struct ShapePickerView_Previews: PreviewProvider {
    static var previews: some View {
        ShapePickerView()
    }
}
